# This file defines most system-dependent values.  You will also have to modify
# include/threading.h.  Makefiles including this file must define BASE to point
# to the directory containing this file (e.g., "..").

# How to link the threads library.  If you change this value, you will also
# have to modify include/threading.h.
#LIBTHREADS = -lpthreads	# For pthreads
LIBTHREADS = -lthread		# For Solaris threads

# Optimization and debugging flags.  I have had *major* problems with AIX
# optimization at any level (I think), so it is not recommended.  TOMPI is
# pretty fast to compile, so you're welcome to try it once you get it running.
# Let me know what success/failure you have (on any operating system).
#OPTFLAGS = -fast		# Solaris optimization (works)
OPTFLAGS = -g			# Debugging mode

# The C compiler.  Also the linker for example programs if you don't change
# LINK below.  IMPORTANT NOTE: Most operating systems require a special
# compiler or flag to use threads (to link re-entrant libc, use re-entrant
# errno, etc.).  Be sure to get this right.
CC = cc -D_REENTRANT		# For Solaris
#CC = cc_r			# For AIX

# How to run the C preprocessor.  Do *not* run cpp directly, since this won't
# pass the appropriate -D's.
CPP = $(CC) -E

# You shouldn't have to change this.  If you're include files are in a funny
# place, you can add -Ipath to the end.
INCLUDES = -I$(BASE)/include

# You also shouldn't have to change this.
CFLAGS = $(OPTFLAGS) $(INCLUDES)

# Change the $(CC) if you want to use a different linker.  See the important
# note for CC above.
LINK = $(CC) $(CFLAGS)

# -------------- No need to change anything below this point. --------------

# How to link the generated MPI library.
LIBMPI = -L$(BASE)/src -lmpi $(LIBTHREADS)

# What file to depend on to recompile when the MPI library changes.
LIBDEP = $(BASE)/src/libmpi.a

