#include "mpii.h"

PUBLIC int MPI_Recv_init (void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Request *request)
{
   if ((source < 0 || source > comm->group->size) && source != MPI_ANY_SOURCE)
      return MPII_Error (comm, MPII_RANK_RANGE);

   request->active = 0;
   request->persistent = 1;
   request->type = MPII_REQUEST_RECV;
   request->comm = comm;
   request->buf = buf;
   request->count = count;
   request->datatype = datatype;
   request->srcdest = source;
   request->tag = tag;

   return MPI_SUCCESS;
}

